dim RefreshTime

RefreshTime = 40

Function Narrative(LocationID,WordWrapAt)
 Narrative = GetText("<!-- insert day/date/time of day -->", "</TD>", 0,LocationID)
 Narrative = Replace(Narrative, "</B>", "")
 Narrative = Replace(Narrative, "&nbsp;", " ")
 Narrative = Replace(Narrative, chr(10), "")
 Narrative = Replace(Narrative, "  ", "")
 Narrative = Breakline(Narrative, WordWrapAt+0)
 Narrative = Replace(Narrative, "%b ", "%b")
End Function

Private Function start(source, pos, offset)
 source = Mid(source, instr(source, pos)+len(pos)+offset)
 Start = Source
End Function

Private Function endd(source, pos, offset)
 source = Mid(source, 1, instr(source, pos)-1-offset)
 endd = Source
End Function

Private Function BreakLine(MyText, LineLength)
 If LineLength <> 0 And len(MyText) > LineLength Then
  BreakLine = ""
  Do While len(MyText) > LineLength
   breakPoint = InStrRev(MyText, " ", LineLength, 1)
   BreakLine = BreakLine & left(MyText, breakPoint) & "%b" & " "
   MyText = right(MyText, len(MyText) - breakPoint)
  loop
  BreakLine = BreakLine & MyText
 else
  BreakLine = MyText
 end if
End Function


Private Function TimeDiff(ZipCode)
 dim fs,f,diff
 set fs=CreateObject("Scripting.FileSystemObject")
 if fs.fileexists(path(ZipCode)) then
  set f=fs.GetFile(path(ZipCode))
  diff = datediff( "n", f.DateLastModified, now())
 else
  diff = -1
 end if
 set f=nothing
 set fs=nothing
 TimeDiff = diff
End Function

Private Function path(ZipCode)
 path = GetTempPath & ZipCode & ".tmp"
End Function

Private Function GetTempPath
 set fso=CreateObject("Scripting.FileSystemObject")
 GetTempPath = fso.GetSpecialFolder(2) & "\weather.com.narrative\" 
 if not fso.FolderExists(GetTempPath) then 
  fso.CreateFolder(GetTempPath)
 End if
End Function

Private Function GetText(ini,Fin,offset,ZipCode)
 If TimeDiff(ZipCode) < 0 Then
  GetText = Writefile(ZipCode)       'file doesn't exist so fetch it
 Else
  If TimeDiff(ZipCode) > RefreshTime Then        'see if it needs refreshing
   GetText = Writefile(ZipCode) 'refresh it
  End If
 End If
 GetText = GetFileContents(ini,Fin,offset,ZipCode)           'read it's contents

End Function

Private Function RandomNum
 Randomize Timer
 RandomNum = Int(Rnd * 1000)
End Function

Private Function GetFileContents(ini,Fin,offset,ZipCode)
 Set file_obj = CreateObject ("Scripting.FileSystemObject")
 Set file_path = file_obj.GetFile(path(ZipCode)) ' Creates the connection to the file
 set file = file_path.OpenAsTextStream (1, -2) ' Opens the file for reading
 html = file.readall
 File.Close ' Closes the file
 Set file_path = nothing ' Resets variable
 Set file_obj = nothing ' Resets variable
 html = start(html, ini, offset)
 html = endd(html, Fin, 0)
 GetFileContents = html
End Function

Private Function Writefile(ZipCode)
 GetURL = "http://www.weather.com/weather/narrative/" & ZipCode & "?" & RandomNum
 
 Dim Http
  Set Http = CreateObject("Microsoft.XMLhttp")
  Http.Open "GET",GetURL,False
  Http.Send
  HtmlResult = Http.ResponseText
  Set Http = Nothing
  Set fs=CreateObject("Scripting.FileSystemObject")
 If (fs.FileExists(path(ZipCode))) Then
  Set aFile = fs.GetFile(path(ZipCode))
  aFile.Delete
  set aFile = nothing
 End If

 Set f=fs.CreateTextFile(path(ZipCode), true, false)
  f.Write HtmlResult
  f.Close
  Set f=Nothing
  Set fs=Nothing
End Function